<?php
/*
Cart
(c) Schien Dong, Antradar Software
*/

include 'settings.cart.php';

/*
Integration Point: Look up the product from your database; return the product name and price
*/

function cart_getproduct($productid){
	
	//Example using the sample data:
	
	global $products;
	$name=$products[$productid]['name'];
	$price=$products[$productid]['price'];
	return array('name'=>$name,'price'=>$price);
	
	/*
	Example using a database:
	
	global $db;
	$query="select * from products where productid=$productid";
	$rs=mysql_query($query,$db);
	$myrow=sql_fetch_array($rs);
	
	$name=$myrow['productname'];
	$price=$myrow['price'];

	return array('name'=>$name,'price'=>$price);	
	*/
}




function str2cart($str){
	$items=array();

	$pairs=explode('|',$str);
	foreach ($pairs as $pair){
		$parts=explode('-',$pair);
		if (count($parts)!=2) continue;
		$key=$parts[0]; $val=$parts[1];
		$items[$key]=$val;
	}

	return $items;
}

function cart2str($items){
	$str='';

	foreach($items as $key=>$item){
		$str.="|$key-$item";
	}

	$str=trim($str,'|');

	return $str;
}

function add2cart(&$items,$productid,$quantity=1){
	$key='p'.$productid;
	if (!isset($items[$key])) $items[$key]=0;
	$items[$key]+=$quantity;
}

function removeitem(&$items,$productid){
	$key='p'.$productid;
	if (!isset($items[$key])) return;
	--$items[$key];
	if ($items[$key]<=0) unset($items[$key]);
}

function clearitem(&$items,$productid){
	$key='p'.$productid;
	unset($items[$key]);
}



function showcartbutton($productid,$items=null){
	global $_COOKIE;
	global $db;
	global $cartpage;

	if (!isset($items)) $items=str2cart($_COOKIE['cart']);
?>
	<span>
		<a style="cursor:pointer;" onclick="addtocart(<?echo $productid;?>,this);"><img src="cart/add.gif"></a>
	<?
		if (isset($items['p'.$productid])){
			$c=$items['p'.$productid];
	?>
	&nbsp; <em><?echo $c;?> item<?echo $c==1?'':'s';?> in cart</em>
	&nbsp;
	<a style="cursor:pointer;" onclick="removecartitem(<?echo $productid;?>,this);"><img src="cart/del.gif"></a>
	&nbsp; &nbsp; <a href="<?echo $cartpage;?>">View Cart</a>
	<?
		}
	?>
	</span>
<?
}

function viewcart($container,$items=null){
	global $_COOKIE;
	//global $db;
	global $cart_hst;
	global $storepage;
	
	if (!isset($items)) $items=str2cart($_COOKIE['cart']);

	$buying=(isset($_POST['ccnum']));

	if (count($items)){
?>
<table>
<tr><td><b>Product</b></td><td style="padding-right:20px;"><b>Quantity</b></td><td style="padding-right:20px;"><b>Unit Price</b></td><td><b>Sub Total</b></td></tr>
<?
	$total=0;
	foreach ($items as $key=>$val){
		$productid=str_replace('p','',$key)+0;
		
		$product=cart_getproduct($productid);
		
		$productname=$product['name'];
		$price=$product['price'];
		$dprice='$'.number_format($price,2);
		$dmprice='$'.number_format($price*$val,2);

		$total+=$price*$val;

?>
<tr>
<td style="padding-right:20px;"><?echo $productname;?></td><td style="text-align:center;padding-right:20px;"><?echo $val;?></td>
<td><?echo $dprice;?></td>
<td style="text-align:right;"><?echo $dmprice;?></td>
<td style="padding-left:20px;">
<a style="cursor:pointer;" onclick="cart_add(<?echo $productid;?>,'<?echo $container;?>');"><img src="cart/add.gif"></a> &nbsp; &nbsp;
<a style="cursor:pointer;" onclick="cart_remove(<?echo $productid;?>,'<?echo $container;?>');"><img src="cart/del.gif"></a>
</td>
</tr>
<?


	}//foreach
?>
<tr><td></td>
<td colspan="2" style="text-align:right;padding-right:10px;">
HST:</td><td colspan="10" style="text-align:right;">$<?echo number_format($total*$cart_hst,2);?>
</td>
</tr>

<tr><td></td>
<td colspan="2" style="text-align:right;padding-right:10px;">
<b>Grand Total</b>:</td><td colspan="10" style="text-align:right;">$<?echo number_format($total*(1+$cart_hst),2);?>
</td>
</tr>

</table>

<?
	$cartfinal=$total*(1+$cart_hst);

	if ($buying){
		$fields=array('ccname'=>'Card holder\'s name','ccnum'=>'Credit card number','expmon'=>'Expiry month','expyear'=>'Expiry year',
			'addr'=>'Shipping address','city'=>'City','prov'=>'Province','country'=>'Country','zip'=>'Postal code');
		$errors=array();
		foreach ($fields as $field=>$label){
			if (trim($_POST[$field])=='') array_push($errors,'Missing field: '.$label);
		}

		if (count($errors)==0){
			$ccname=$_POST['ccname'];
			$ccnum=$_POST['ccnum'];
			$expmon=$_POST['expmon'];
			$expyear=$_POST['expyear'];
			$addr=$_POST['addr'];
			$city=$_POST['city']; $prov=$_POST['prov']; $zip=$_POST['zip']; $country=$_POST['country'];

			// Integration Point: post to payment gateway to process credit card
			
			/* Example:
			$res=process_mtrex($ccname,$ccnum,$expyear,$expmon,$cartfinal);
			if ($res['mp_TransResult']!='Approved') array_push($errors,$res['mp_TransResultMessage']);
			*/

			if (count($errors)==0){
	
				//Integration Point: store transaction data; place order; reduce product availability, etc.

				cart_showthankyou();
			} else cart_showpaymentform($errors);
		} else cart_showpaymentform($errors);

	} else cart_showpaymentform();

  } else {
?>
<div>
You have no items in the cart.<br>
Back to <a href="<?echo $storepage;?>">Store</a>?
</div>
<?

  }
}

function cart_showthankyou(){
	global $storepage;
?>
<div style="padding:20px 0;">
<h2>Payment Received</h2>

Thank you for your payment. We will ship your order shortly!
<br><br>
<a href="<?echo $storepage;?>">back to Store</a>
</div>
<?

}

function cart_showpaymentform($errors=null){

?>
	<h2>Check Out</h2>
<?
	if (isset($errors)&&is_array($errors)&&count($errors)){
?>
<div style="padding:10px 0;color:#ab0200;">
<?foreach ($errors as $error){?>
<div><?echo $error;?></div>
<?}?>
</div>
<?
	}
?>

			<form method="POST" style="padding:0;margin:0;">

			<table cellspacing="0" cellpadding="0">
			<tr><td style="padding-right:20px;">Name on Card:</td>
			<td><input name="ccname" value="<?echo stripslashes($_POST['ccname']);?>"></td>
			</tr>

			<tr><td>Card Number:</td>
			<td><input name="ccnum" autocomplete="off"></td>
			</tr>
		
			<tr><td>Expiry:</td>
			<td>
			<?
				$months=array('','Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');
			?>
				<select name="expmon">
				<?foreach ($months as $idx=>$mon){
				?>
				<option value="<?echo $idx;?>" <?if ($idx==$_POST['expmon']) echo 'selected';?>><?echo $mon;?></option>
				<?
				}?>
				</select> /
				<select name="expyear">
				<?
				$year=date('Y');
				for ($i=0;$i<10;$i++){
				?>
				<option value="<?echo $year+$i;?>" <?if ($year+$i==$_POST['expyear']) echo 'selected';?>><?echo $year+$i;?></option>
				<?
				}
				?>
				</select>
			</td>
			</tr>
			<tr><td colspan="2">&nbsp;</td></tr>

			<tr><td colspan="2"><b>Shipping Info</b></td></tr>


			<tr><td>Address:</td>
			<td><input name="addr" style="width:250px;" value="<?echo stripslashes($_POST['addr']);?>"></td>
			</tr>
			
			<tr><td>City:</td>
			<td><input name="city" style="width:100px;" value="<?echo stripslashes($_POST['city']);?>">&nbsp;
			Province: <input name="prov" style="width:60px;" value="<?echo stripslashes($_POST['prov']);?>">
			</td>
			</tr>

			<tr><td>Country:</td>
			<td><input name="country" style="width:80px;" value="<?echo stripslashes($_POST['country']);?>"> &nbsp; &nbsp; 
			Postal: <input name="zip" style="width:70px;" value="<?echo stripslashes($_POST['zip']);?>">
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>

			<tr><td></td>
			<td><input type="submit" value="Buy Now"></td>
			</tr>
			</table>
			
			</form>
<?


}